import nealParams as nealParameters
if (nealParameters.pynnVersion=="pynn")and(nealParameters.simulator=="spinnaker"):
    import pyNN.spiNNaker as sim
elif (nealParameters.pynnVersion=="pynn")and(nealParameters.simulator=="nest"):
    import pyNN.nest as sim
    import cPickle as pickle
elif (nealParameters.pynnVersion=="pynest")and(nealParameters.simulator=="nest"):
    import nest as nest


#Functions to isolate differences between different list synapse constructors
class NealCoverFunctions:
    def __init__(self, simName):
        """
        self.DELAY = 1.0
        self.simulator = simName
        if self.simulator == "nest":
            exec("from nest import *")
        elif self.simulator == 'spinnaker':
            exec("from pyNN.spiNNaker import *")

        else: print "bad simulator in nealFunctions"
        """

    def nealProjection(self,preNeurons,postNeurons, connectorList,inhExc):
        if (nealParameters.pynnVersion=="pynn"):
            connList = sim.FromListConnector(connectorList)
            if (nealParameters.simulator=="spinnaker"):
                sim.Projection(preNeurons, postNeurons, connList,target=inhExc)   
            elif (nealParameters.simulator=="nest"):
                  sim.Projection(preNeurons, postNeurons, connList) 
        elif (nealParameters.pynnVersion=="pynest")and(nealParameters.simulator=="nest"):
            #print 'nest', connectorList
            for connection in connectorList:
                nest.Connect(preNeurons[connection[0]],
                             postNeurons[connection[1]],
                             {'weight':connection[2]})

        else: print "bad simulator nealProjection"

